//=============================================================================
//  MuseScore
//  Linux Music Score Editor
//  $Id:$
//
//  Concertina plugin
//  This version is for the 20 key Anglo Concertina with the Wheatstone keyboard
//
//  Copyright (C)2011 Rich Helms, Werner Schweer and others
//  This is a variation of Werner Schweer very famous recorder_fingering plugin.
//
//  Rich Helms at rich@richhelms.ca
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License version 2.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//=============================================================================

//
// This is ECMAScript code (ECMA-262 aka "Java Script")
//

// from one octave below middle C
// c means C
// C means C Sharp
// starts on note 48 - See http://musescore.org/en/plugin-development/note-pitch-values for pitch details
// 60 is middle C
var fingerings = [ 
"c", "C", "d", "D", "e", "f", "F", "g", "G", "a", "A", "b", 
"c", "C", "d", "D", "e", "f", "F", "g", "G", "a", "A", "b", 
"c", "C", "d", "D", "e", "f", "F", "g", "G", "a", "A", "b",  
"c", "C", "d", "D", "e", "f", "F", "g", "G", "a", "A", "b"
] 
// which button to show. If two put \n between entries
var button =  [ 
"1'", " ", " ", " ", "", "", " ", "2'\n1'", " ", "1", " ", "1\n2'", 
"3'", " ", "2", " ", "4'", "4'", "2", "3", " ", "3", " ", "4", 
"4", " ", "5", " ", "5", "8'", "6", "6", "", "7", "", "7", 
"9'\n8", " ", "8", " ", "10'\n9", " ", "10", "9", " ", " ", " ", "10"
] 
// Put underscore under button number if shoud PUSH rather than draw to produce
var pushpull = [ 
"_" , " ", " ", " ", " ", " ", " ", "_", " ", " ", " ", "_", 
"_",  " ",   "_", " ",   "_",  " ",  " ", "_", " ",   " ", " ",   "_", 
" ", " ",   "_", " ",   " ", " ",  " ", "_", " ",   " ", " ",   "_", 
"_", " ", "_", " ", "_", " ", " ", "_", " ", " ", " ", "_", 
] 

//---------------------------------------------------------
//    init
//    this function will be called on startup of mscore
//---------------------------------------------------------

function init()
      {
      // print("test script init");
      }

//-------------------------------------------------------------------
//    run
//    this function will be called when activating the
//    plugin menu entry
//
//    global Variables:
//    pluginPath - contains the plugin path; file separator is "/"
//-------------------------------------------------------------------

function run()
      {
      var cursor   = new Cursor(curScore);
      cursor.staff = 0;
      cursor.voice = 0;
      cursor.rewind();  // set cursor to first chord/rest
      while (!cursor.eos()) {
            if (cursor.isChord()) {
                  
                  var pitch = cursor.chord().topNote().pitch;
                  var index = pitch - 48;
                  if(index >= 0 && index < button.length){ 
                      var text  = new Text(curScore);
                      text.text = button[index];
                      text.yOffset = 6;
                      cursor.putStaffText(text);

                      var text2  = new Text(curScore);
                      text2.text = pushpull[index];
                      text2.yOffset = 6;
                      cursor.putStaffText(text2);
                      }
                  }
            cursor.next();
            }
      }

//---------------------------------------------------------
//    menu:  defines were the function will be placed
//           in the MuseScore menu structure
//---------------------------------------------------------

var mscorePlugin = {
      menu: 'Plugins.Anglo_20_key_Concertina',
      init: init,
      run:  run
      };

mscorePlugin;

